/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 2 juillet 2007
   derniere modification le 03/07/2007 */


#ifndef __SCEFRAMEBUFFER_H__
#define __SCEFRAMEBUFFER_H__


/* constantes de CFramebuffer */
/* types de buffers */
#define SCE_COLOR_BUFFER 0
#define SCE_DEPTH_BUFFER 1
#define SCE_STENCIL_BUFFER 2
/* nombre de render buffer differents */
#define SCE_NUM_RENDER_BUFFERS 3


/* buffer de rendu, soit vers un ID, soit vers une texture */
typedef struct sce_crenderbuffer SCE_CRenderBuffer;
struct sce_crenderbuffer
{
    SCEuint id;
    SCE_CTexture *tex;
    int user;               /* booleen, true: la texture appartient
                               a l'utilisateur */
    int clear;              /* booleen, true: le tampon doit etre
                               vide a chaque rendu */
};

/* Frame Buffer Object */
typedef struct sce_cframebuffer SCE_CFramebuffer;
struct sce_cframebuffer
{
    SCEuint id;             /* identifiant opengl */
    
    GLbitfield mask;        /* tampons a mettre a jour */
    
    /* tampons de ce FBO */
    SCE_CRenderBuffer buffers[SCE_NUM_RENDER_BUFFERS];
    
    int x, y, w, h;
};


/* cree un FBO */
SCE_CFramebuffer* SCE_CCreateFramebuffer(void);

/* supprime un FBO */
void SCE_CDeleteFramebuffer(SCE_CFramebuffer*);


/* ajoute un tampon de rendu vers une texture */
void SCE_CAddRenderTexture(SCE_CFramebuffer*, SCEuint,
                           SCEenum, SCE_CTexture*, int);

/* ajoute un tampon de rendu vers ... rien :D */
void SCE_CAddRenderBuffer(SCE_CFramebuffer*, SCEuint, int, int, int);

/* cree une texture et l'ajoute comme render texture */
int SCE_CCreateRenderTexture(SCE_CFramebuffer*, SCEuint,
                             int, int, int, int, int);

/* recupere la texture de rendu du render buffer specifie */
SCE_CTexture* SCE_CGetRenderTexture(SCE_CFramebuffer*, SCEuint);


/* defini si le buffer specifie du FBO doit etre vide avant le rendu */
void SCE_CClearRenderbuffer(SCE_CFramebuffer*, SCEuint, int);


/* defini le frame buffer actif */
void SCE_CUseFramebuffer(SCE_CFramebuffer*, SCE_CRect*);


#endif /* guard */
