/***************************************************************************
 *   Copyright (C) 2007  Antony Martin <martin.antony@yahoo.fr>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU General Public License           *
 *   as published by the Free Software Foundation; either version 2        *
 *   of the License, or (at your option) any later version.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

/* Cree le : 31 mai 2007
   derniere modification : 31/05/2007 */


#ifndef __SCECMATERIAL_H__
#define __SCECMATERIAL_H__


/* types de couleurs */
#define SCE_DIFFUSE_COLOR 0
#define SCE_EMISSIVE_COLOR 1
#define SCE_SPECULAR_COLOR 2
#define SCE_AMBIENT_COLOR 3
#define SCE_SHININESS_COLOR 4
/* nombre de types de couleur */
#define SCE_NUM_COLORS 5


typedef struct sce_cmaterial SCE_CMaterial;
struct sce_cmaterial
{
    /* couleurs du materiau */
    float colors[SCE_NUM_COLORS][4];
};


/* cree un materiau */
SCE_CMaterial* SCE_CCreateMaterial(void);

/* supprime un materiau */
void SCE_CDeleteMaterial(SCE_CMaterial*);


/* assigne une couleur a un materiau */
void SCE_CSetColorMaterial(SCE_CMaterial*, SCEenum, float, float, float, float);
/* version vectorielle */
void SCE_CSetColorMaterialv(SCE_CMaterial*, SCEenum, float*);


/* defini le materiau actif */
void SCE_CUseMaterial(SCE_CMaterial*);


#endif /* guard */
